package jp.co.intra_mart.tools.bm5.csv2xml.common;

import java.text.MessageFormat;
import java.util.ResourceBundle;

/**
 * bZ[W\[X戵NXłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class MessageManager {
    /**
     * bZ[Woh̊ꖼ
     */
    public static String BASE_NAME = "jp.co.intra_mart.tools.bm5.csv2xml.message";
    
    private static final String NOT_EXIST_MESSAGE = "No Message";

    /**
     * RXgN^
     * 
     * CX^X͕̐s
     */
    private MessageManager() {
    }
    
    /**
     * bZ[W擾܂B
     * 
     * @param key bZ[WL[
     * @return bZ[W
     */
    public static String getMessage(String key) {
        try {
            return getBundle().getString(key);
        } catch (Exception e) {
            e.printStackTrace();
            return NOT_EXIST_MESSAGE;
        }
    }

    /**
     * bZ[W擾܂B
     * 
     * @param key bZ[WL[
     * @param parameter p[^
     * @return bZ[W
     */
    public static String getMessage(String key, String[] parameter) {
        try {
            if (parameter == null || parameter.length == 0) {
                return getMessage(key);
            } else {
                return MessageFormat.format(getBundle().getString(key), parameter);
            }
        } catch (Exception e) {
            e.printStackTrace();
            return NOT_EXIST_MESSAGE;
        }
    }

    /**
     * w肳ꂽŃ\[Xoh擾܂B
     * 
     * @param baseName ꖼ
     * @param locale 
     * @return \[Xoh
     */
    private static ResourceBundle getBundle() {
        return ResourceBundle.getBundle(BASE_NAME);
    }
}
