package jp.co.intra_mart.tools.bm5.csv2xml.models.common;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;


/**
 * ދ敪Ɋւ郂fłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class CategoryClass implements Serializable {
    /**
     * ދ敪R[h
     */
    private final String categoryClassCode;
    /**
     * ޏi[}bv
     */
    private Map categories = new HashMap();
    
    /**
     * RXgN^
     * 
     * @param categoryClassCode ދ敪R[h
     */
    public CategoryClass(String categoryClassCode) {
        this.categoryClassCode = categoryClassCode;
    }
    
    /**
     * ދ敪R[h擾܂B
     * 
     * @return ދ敪R[h
     */
    public String getCategoryClassCode() {
        return this.categoryClassCode;
    }
    
    /**
     * ޏݒ肵܂B
     * 
     * @param category 
     */
    public void addCategory(Category category) {
        if (categories.containsKey(category.getCategoryCode())) {
            // ̕ނ݂
            throw new ModelBuilderException("MW-401", new String[] {
                    getCategoryClassCode(), category.getCategoryCode() });
        }
        
        categories.put(category.getCategoryCode(), category);
        category.setCategoryClassCode(getCategoryClassCode());
    }
    
    /**
     * ޏ擾܂B
     * 
     * @param categoryCode JeSR[h
     * @return ޏ
     */
    public Category getCategory(String categoryCode) {
        return (Category) categories.get(categoryCode);
    }
    
    /**
     * ޏ̈ꗗ擾܂B
     * 
     * @return ޏ̈ꗗ
     */
    public Category[] getCategories() {
        return (Category[]) categories.values().toArray(new Category[categories.size()]);
    }

    
    public int hashCode() {
        return getCategoryClassCode().hashCode();
    }
    
    public boolean equals(Object obj) {
        if (obj == null || !(obj instanceof CategoryClass)) {
            return false;
        }
        return (this.hashCode() == obj.hashCode());
    }
}
