package jp.co.intra_mart.tools.bm5.csv2xml.models.common;

import java.io.Serializable;

/**
 * Kw\o[WɊւ郂fłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class Version implements Serializable {
    /**
     * o[WR[h
     */
    private final String versionCode;
    /**
     * o[W
     */
    private final Term term;
    /**
     * l
     */
    private String notes = null;
    
    /**
     * RXgN^
     * 
     * @param versionCode o[WR[h
     * @param term 
     */
    public Version(String versionCode, Term term) {
        ValueConverter.checkNull("VERSION_CODE", versionCode);
        this.versionCode = versionCode;
        this.term = term;
    }
    
    /**
     * o[WR[h擾܂B
     * 
     * @return o[WR[h
     */
    public String getVersionCode() {
        return this.versionCode;
    }
    
    /**
     * Ԃ擾܂B
     * 
     * @return 
     */
    public Term getTerm() {
        return this.term;
    }
    
    /**
     * lݒ肵܂B
     * 
     * @param notes l
     */
    public void setNotes(String notes) {
        this.notes = notes;
    }
    
    /**
     * l擾܂B
     * 
     * @return l
     */
    public String getNotes() {
        return this.notes;
    }

    public int hashCode() {
        return getVersionCode().hashCode();
    }
    
    public boolean equals(Object obj) {
        if (obj == null || !(obj instanceof Version)) {
            return false;
        }
        
        Version version = (Version) obj;
        return (this.hashCode() == version.hashCode());
    }
}