package jp.co.intra_mart.tools.bm5.csv2xml.models.post;

import java.io.Serializable;
import java.util.Locale;

import jp.co.intra_mart.common.aid.jdk.java.util.LocaleUtil;
import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ValueConverter;

/**
 * Eԍۉێ܂B
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class PostTermI18n implements Serializable {
    /**
     * Eԉ
     */
    private PostTerm postTerm = null;
    /**
     * 
     */
    private final Locale locale;
    /**
     * E
     */
    private String name = null;
    
    /**
     * RXgN^
     * 
     * @param locale 
     */
    public PostTermI18n(String locale) {
        ValueConverter.checkNull(Const.LOCALE, locale);
        this.locale = LocaleUtil.toLocale(locale);
    }

    /**
     * 擾܂B
     * 
     * @return 
     */
    public Locale getLocale() {
        return this.locale;
    }

    /**
     * E擾܂B
     * 
     * @return E
     */
    public String getName() {
        return name;
    }

    /**
     * Eݒ肵܂B
     * 
     * @param name E
     */
    public void setName(String name) {
        ValueConverter.checkNull(Const.POST_NAME, name);
        this.name = name;
    }

    /**
     * Eԉݒ肵܂B
     * 
     * @param postTerm Eԉ
     */
    void setPostTerm(PostTerm postTerm) {
        this.postTerm = postTerm;
    }
    
    /**
     * Eԉ擾܂B
     * 
     * @return Eԉ
     */
    PostTerm getPostTerm() {
        return this.postTerm;
    }
}
