package jp.co.intra_mart.tools.bm5.csv2xml.models.public_group;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;

/**
 * pubNO[vZbgێ}bvłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class PublicGroupSetMap implements Serializable {
    /**
     * pubNO[vZbg̃Xg
     */
    private List groupSet = new ArrayList();
    /**
     * pubNO[vZbg̃}bv
     */
    private Map groupSetMap = new HashMap();

    /**
     * pubNO[vZbgݒ肵܂B
     * 
     * @param publicGroupSet pubNO[vZbg
     */
    public void addPublicGroupSet(PublicGroupSet publicGroupSet) {
        if (groupSetMap.containsKey(publicGroupSet.getPublicGroupSetCode())) {
            // ̃O[vZbgR[hłɑ݂
            throw new ModelBuilderException("MW-201",
                    new String[] { publicGroupSet.getPublicGroupSetCode() });
        }
        groupSetMap.put(publicGroupSet.getPublicGroupSetCode(), publicGroupSet);
        groupSet.add(publicGroupSet);
    }
    
    /**
     * pubNO[vZbg擾܂B
     * 
     * @param publicGroupSetCode pubNO[vZbgR[h
     * @return pubNO[vZbg
     */
    public PublicGroupSet getPublicGroupSet(String publicGroupSetCode) {
        if (!groupSetMap.containsKey(publicGroupSetCode)) {
            // ̃O[vZbgR[hłɑ݂
            throw new ModelBuilderException("MW-202", new String[] { publicGroupSetCode });
        }
        return (PublicGroupSet) groupSetMap.get(publicGroupSetCode);
    }
    
    /**
     * pubNO[vZbg̈ꗗԂ܂B
     * 
     * @return pubNO[vZbg̈ꗗ
     */
    public PublicGroupSet[] getPublicGroupSet() {
        return (PublicGroupSet[]) groupSet.toArray(new PublicGroupSet[groupSet.size()]);
    }
}
