package jp.co.intra_mart.tools.bm5.csv2xml.models.common;

import java.io.Serializable;
import java.util.SortedSet;
import java.util.TreeSet;


/**
 * ޏɊւ郂fłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class Category implements Serializable {
    /**
     * ދ敪R[h
     */
    private String categoryClassCode = null;
    /**
     * ރR[h
     */
    private final String categoryCode;
    /**
     * 
     */
    private SortedSet terms = new TreeSet();

    /**
     * RXgN^
     * 
     * @param categoryCode ރR[h
     */
    public Category(String categoryCode) {
        ValueConverter.checkNull("CATEGORY_CODE", categoryCode);
        this.categoryCode = categoryCode;
    }
    
    /**
     * ދ敪ݒ肵܂B
     * 
     * @param categeoryClassCode ދ敪
     */
    public void setCategoryClassCode(String categoryClassCode) {
        this.categoryClassCode = categoryClassCode;
    }
    
    /**
     * ދ敪R[h擾܂B
     * 
     * @return ދ敪R[h
     */
    public String getCategoryClassCode() {
        return this.categoryClassCode;
    }

    /**
     * ރR[h擾܂B
     * 
     * @return ރR[h
     */
    public String getCategoryCode() {
        return this.categoryCode;
    }

    /**
     * Ԃݒ肵܂B
     * 
     * @param term
     */
    public void addTerm(Term term) {
        try {
            if (terms.contains(term)) {
                // ̕ނ݂
                throw new ModelBuilderException("MW-402", new String[] {
                        getCategoryClassCode(), getCategoryCode(), term.toString() });
            }
            this.terms.add(term);
        } catch (IllegalArgumentException e) {
            // ԂdȂ敪񂪑݂
            throw new ModelBuilderException("MW-403", new String[] {
                    getCategoryClassCode(), getCategoryCode(), term.toString() });
        }
    }
    
    /**
     * Ԃ̈ꗗԂ܂B
     * 
     * @return Ԃ̈ꗗ
     */
    public Term[] getTerms() {
        return (Term[]) terms.toArray(new Term[terms.size()]);
    }
    
    public int hashCode() {
        return getCategoryCode().hashCode();
    }
    
    public boolean equals(Object obj) {
        if (obj == null || !(obj instanceof Category)) {
            return false;
        }
        return (this.hashCode() == obj.hashCode());
    }
}
