package jp.co.intra_mart.tools.bm5.csv2xml.models.common;

import java.util.ArrayList;
import java.util.List;

/**
 * f̐ɃX[ONXłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class ModelBuilderException extends RuntimeException {
    /**
     * bZ[WL[
     */
    private final String key;
    /**
     * bZ[Wp[^
     */
    private final List parameter = new ArrayList();
    
    /**
     * RXgN^
     * 
     * @param key bZ[WL[
     */
	public  ModelBuilderException(String key) {
		this.key = key;
	}
	
    /**
     * RXgN^
     * 
     * @param key bZ[WL[
     * @param parameter p[^
     */
    public ModelBuilderException(String key, String parameter) {
        this(key);
        addParameter(parameter);
    }
    
    /**
     * RXgN^
     * 
     * @param key bZ[WL[
     * @param parameter p[^
     */
	public ModelBuilderException(String key, String[] parameter) {
        this(key);
        addParameter(parameter);
	}
    
    /**
     * bZ[WL[擾܂B
     * 
     * @return bZ[WL[
     */
    public String getKey() {
        return this.key;
    }

    /**
     * bZ[Wp[^ݒ肵܂B
     * 
     * @param parameter bZ[Wp[^
     */
    public void addParameter(String parameter) {
        addParameter(new String[] { parameter });
    }

    /**
     * bZ[Wp[^ݒ肵܂B
     * 
     * @param parameter bZ[Wp[^
     */
    public void addParameter(String[] parameter) {
        if (parameter != null && parameter.length > 0) {
            for (int i= 0; i < parameter.length; i++) {
                this.parameter.add(parameter[i]);
            }
        }
    }
    
    /**
     * bZ[W̃p[^擾܂B
     * 
     * @return bZ[Wp[^
     */
    public List getParameter() {
        return this.parameter;
    }
}
