package jp.co.intra_mart.tools.bm5.csv2xml.models.company;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;

/**
 * Џێ}bvłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class CompanyMap implements Serializable {
    /**
     * Ђ̃Xg
     */
    private List companyList = new ArrayList();
    /**
     * Ђ̃}bv
     */
    private Map companyMap = new HashMap();

    /**
     * Ђݒ肵܂B
     * 
     * @param company 
     */
    public void addCompany(Company company) {
        if (companyMap.containsKey(company.getCompanyCode())) {
            // ̉ЃR[hłɑ݂
            throw new ModelBuilderException("MW-001", new String[] { company
                    .getCompanyCode() });
        }
        companyMap.put(company.getCompanyCode(), company);
        companyList.add(company);
    }
    
    /**
     * Ђ擾܂B
     * 
     * @param companyCode ЃR[h
     * @return 
     */
    public Company getCompany(String companyCode) {
        if (!companyMap.containsKey(companyCode)) {
            // YЂ݂Ȃ
            throw new ModelBuilderException("MW-002", new String[] { companyCode });
        }
        return (Company) companyMap.get(companyCode);
    }
    
    /**
     * Ђ̈ꗗԂ܂B
     * 
     * @return Ђ̈ꗗ
     */
    public Company[] getCompany() {
        return (Company[]) companyList.toArray(new Company[companyList.size()]);
    }
}
