/*
 * DepartmentTerminableInternational.java
 *
 * Created on 2005/03/31, 12:00:00
 */
package jp.co.intra_mart.tools.bm5.csv2xml.models.company;

import java.io.Serializable;
import java.util.Locale;

import jp.co.intra_mart.common.aid.jdk.java.util.LocaleUtil;
import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ValueConverter;

/**
 * gD̊ԍۉ̃f[^舵܂B
 *
 * @author intra-mart
 * @since 5.0
 */
public class DepartmentTermI18n implements Serializable {
    /**
     * gDԉ
     */
    private DepartmentTerm departmentTerm = null;
    /**
     * 
     */
    private final Locale locale;
    /**
     * gD
     */
    private String name;
    /**
     * gDJi
     */
    private String nameSyllabary;
    /**
     * gDp
     */
    private String nameEnglish;
    /**
     * Z1
     */
    private String address1;
    /**
     * Z2
     */
    private String address2;

    /**
     * RXgN^
     * 
     * @param locale 
     */
    public DepartmentTermI18n(String locale) {
        ValueConverter.checkNull(Const.LOCALE, locale);
        this.locale = LocaleUtil.toLocale(locale);
    }
    
    /**
     * 擾܂B
     * 
     * @return 
     */
    public Locale getLocale() {
        return this.locale;
    }
    
    /**
     * gD擾܂B
     * 
     * @return gD
     */
    public String getName() {
        return this.name;
    }

    /**
     * gDݒ肵܂B
     * 
     * @param name gD
     */
    public void setName(String name) {
        ValueConverter.checkNull(Const.DEPARTMENT_NAME, name);
        this.name = name;
    }

    /**
     * gDJi擾܂B
     * 
     * @return gDJi
     */
    public String getNameSyllabary() {
        return this.nameSyllabary;
    }

    /**
     * gDJiݒ肵܂B
     * 
     * @param nameSyllabary gDJi
     */
    public void setNameSyllabary(String nameSyllabary) {
        this.nameSyllabary = nameSyllabary;
    }

    /**
     * gDp擾܂B
     * 
     * @return gDp
     */
    public String getNameEnglish() {
        return this.nameEnglish;
    }

    /**
     * gDpݒ肵܂B
     * 
     * @param nameEnglish gDp
     */
    public void setNameEnglish(String nameEnglish) {
        this.nameEnglish = nameEnglish;
    }

    /**
     * Z1擾܂B
     * 
     * @return Z1
     */
    public String getAddress1() {
        return this.address1;
    }

    /**
     * Z1ݒ肵܂B
     * 
     * @param address1 Z1
     */
    public void setAddress1(String address1) {
        this.address1 = address1;
    }

    /**
     * Z2擾܂B
     * 
     * @return Z2
     */
    public String getAddress2() {
        return this.address2;
    }

    /**
     * Z2ݒ肵܂B
     * 
     * @param address2 Z2
     */
    public void setAddress2(String address2) {
        this.address2 = address2;
    }
    
    /**
     * gDԉݒ肵܂B
     * 
     * @param departmentTerm gDԉ
     */
    void setDepartmentTerm(DepartmentTerm departmentTerm) {
        this.departmentTerm = departmentTerm;
    }
    
    /**
     * gDԉ擾܂B
     * 
     * @return gDԉ
     */
    DepartmentTerm getDepartmentTerm() {
        return this.departmentTerm;
    }
}