package jp.co.intra_mart.tools.bm5.csv2xml.models.post;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;

/**
 * EԂɊւ郂fłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class PostTerm implements Serializable {
    /**
     * E
     */
    private Post post = null;
    /**
     * 
     */
    private final Term term;
    /**
     * E̊ԍۉɊ֘Ã}bv
     */
    private Map locales = new HashMap();
    
    /**
     * RXgN^
     * 
     * @param term 
     */
    public PostTerm(Term term) {
        this.term = term;
    }
    
    /**
     * ԂԂ܂B
     * 
     * @return 
     */
    public Term getTerm() {
        return this.term;
    }
    
    /**
     * w肳ꂽɑ΂ԍۉݒ肵܂B
     * 
     * @param locale iP[j
     * @param model ԍۉ
     */
    public void addTerminableInternational(PostTermI18n model) {
        if (locales.containsKey(model.getLocale())) {
            // łɓo^ς݂̊ԍۉ񂪂
            throw new ModelBuilderException("MW-104", new String[] {
                    getPost().getCompanyCode(),
                    getPost().getPostCode(), getTerm().toString(),
                    model.getLocale().toString() });
        }
        this.locales.put(model.getLocale(), model);
        model.setPostTerm(this);
    }

    /**
     * w肳ꂽɑ΂ԍۉ擾܂B
     * 
     * @param locale iP[j
     * @return ԍۉ
     */
    public PostTermI18n getTerminableInternational(Locale locale) {
        if (!locales.containsKey(locale)) {
            // Yԍۉ񂪑݂Ȃ
            throw new ModelBuilderException("MW-106", new String[] {
                    getPost().getCompanyCode(),
                    getPost().getPostCode(), getTerm().toString(),
                    locale.toString() });
        }
        return (PostTermI18n) this.locales.get(locale);
    }
    
    /**
     * ԍۉ̈ꗗ擾܂B
     * 
     * @return ԍۉ̈ꗗ
     */
    public PostTermI18n[] getTerminableInternationals() {
        return (PostTermI18n[]) locales.values().toArray(
                new PostTermI18n[locales.size()]);
    }

    /**
     * Eݒ肵܂B
     * 
     * @param post E
     */
    void setPost(Post post) {
        this.post = post;
    }
    
    /**
     * E擾܂B
     * 
     * @return E
     */
    Post getPost() {
        return this.post;
    }
}
