package jp.co.intra_mart.tools.bm5.csv2xml.models.public_group;

import java.io.Serializable;
import java.util.Locale;

import jp.co.intra_mart.common.aid.jdk.java.util.LocaleUtil;
import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ValueConverter;

/**
 * pubNO[vԍۉfłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class PublicGroupTermI18n implements Serializable {
    /**
     * ԉ
     */
    private PublicGroupTerm groupTerm = null;
    /**
     * 
     */
    private final Locale locale;
    /**
     * O[v
     */
    private String name;
    /**
     * O[vJi
     */
    private String nameSyllabary;
    /**
     * O[vp
     */
    private String nameEnglish;
    
    /**
     * RXgN^
     * 
     * @param term 
     * @param locale 
     */
    public PublicGroupTermI18n(String locale) {
        ValueConverter.checkNull(Const.LOCALE, locale);
        this.locale = LocaleUtil.toLocale(locale);
    }
    
    /**
     * 擾܂B
     * 
     * @return 
     */
    public Locale getLocale() {
        return this.locale;
    }
    
    /**
     * O[v擾܂B
     * 
     * @return O[v
     * @throws AccessorException f[^̎擾Ɏsꍇ
     */
    public String getName() {
        return this.name;
    }

    /**
     * O[vݒ肵܂B
     * 
     * @param name O[v
     */
    public void setName(String name) {
        ValueConverter.checkNull(Const.PUBLIC_GROUP_NAME, name);
        this.name = name;
    }

    /**
     * O[vJi擾܂B
     * 
     * @return O[vJi
     * @throws AccessorException f[^̎擾Ɏsꍇ
     */
    public String getNameSyllabary() {
        return this.nameSyllabary;
    }

    /**
     * O[vJiݒ肵܂B
     * 
     * @param nameSyllabary O[vJi
     */
    public void setNameSyllabary(String nameSyllabary) {
        this.nameSyllabary = nameSyllabary;
    }

    /**
     * O[vp擾܂B
     * 
     * @return O[vp
     * @throws AccessorException f[^̎擾Ɏsꍇ
     */
    public String getNameEnglish() {
        return this.nameEnglish;
    }

    /**
     * O[vpݒ肵܂B
     * 
     * @param nameEnglish O[vp
     */
    public void setNameEnglish(String nameEnglish) {
        this.nameEnglish = nameEnglish;
    }

    /**
     * pubNO[vԉݒ肵܂B
     * 
     * @param groupTerm pubNO[vԉ
     */
    void setPublicGroupTerm(PublicGroupTerm groupTerm) {
        this.groupTerm = groupTerm;
    }

    /**
     * pubNO[vԉ擾܂B
     * 
     * @param pubNO[vԉ
     */
    PublicGroupTerm getPublicGroupTerm() {
        return this.groupTerm;
    }
}
