package jp.co.intra_mart.tools.bm5.csv2xml.models.user;

import java.io.Serializable;

import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ValueConverter;

/**
 * AJEgɐݒ肳AvP[V[̃fłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class ApplicationRole implements Serializable {
    /**
     * AJEg
     */
    private Account account = null;
    /**
     * AvP[V[
     */
    private final String applicationRole;
    
    /**
     * RXgN^
     * 
     * @param applicationRole AvP[V[ID
     */
    public ApplicationRole(String applicationRole) {
        ValueConverter.checkNull(Const.APPLICATION_ROLE_ID, applicationRole);
        this.applicationRole = applicationRole;
    }
    
    /**
     * AvP[V[ID擾܂B
     * 
     * @return AvP[V[ID
     */
    public String getApplicationRole() {
        return this.applicationRole;
    }
    
    /**
     * AJEgݒ肵܂B
     * 
     * @param account AJEg
     */
    public void setAccount(Account account) {
        this.account = account;
    }
    
    /**
     * [UR[h擾܂B
     * 
     * @return [UR[h
     */
    public String getUserCode() {
        return (this.account == null) ? null : account.getUserCode();
    }


    public int hashCode() {
        return getApplicationRole().hashCode();
    }
    
    public boolean equals(Object obj) {
        if (obj == null || !(obj instanceof ApplicationRole)) {
            return false;
        }
        return (this.hashCode() == obj.hashCode());
    }
}
