package jp.co.intra_mart.tools.bm5.csv2xml.models.user;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ModelBuilderException;
import jp.co.intra_mart.tools.bm5.csv2xml.models.company.Company;

/**
 * ЏɊւ郂fłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class CompanyMember implements Serializable {
    /**
     * [U
     */
    private User user = null;
    /**
     * 
     */
    private final Company company;
    /**
     * gD
     */
    private Map members = new HashMap();
    
    /**
     * RXgN^
     * 
     * @param company 
     */
    public CompanyMember(Company company) {
        this.company = company;
    }
    
    /**
     * ЃR[h擾܂B
     * 
     * @return ЃR[h
     */
    public String getCompanyCode() {
        return company.getCompanyCode();
    }
    
    /**
     * gDݒ肵܂B
     * 
     * @param member 
     */
    public void addDepartmentMember(DepartmentMember member) {
        if (members.containsKey(member.getDepartmentCode())) {
            // ̑gD񂪑݂
            throw new ModelBuilderException("MW-316", new String[] {
                    user.getUserCode(), getCompanyCode(),
                    member.getDepartmentCode() });
        }
        members.put(member.getDepartmentCode(), member);
        member.setCompanyMember(this);
    }
    
    /**
     * w肳ꂽgDR[hɈvgD擾܂B
     * 
     * @param departmentCode gDR[h
     * @return gD
     */
    public DepartmentMember getDepartmentMember(String departmentCode) {
        return (DepartmentMember) members.get(departmentCode);
    }
    
    /**
     * gD̈ꗗ擾܂B
     * 
     * @return gD̈ꗗ
     */
    public DepartmentMember[] getDepartmentMembers() {
        return (DepartmentMember[]) members.values().toArray(new DepartmentMember[members.size()]);
    }

    /**
     * [Uݒ肵܂B
     * 
     * @param user [U
     */
    void setUser(User user) {
        this.user = user;
    }
    
    /**
     * [U擾܂B
     * 
     * @return [U
     */
    User getUser() {
        return this.user;
    }
}
