package jp.co.intra_mart.tools.bm5.csv2xml.models.user;

import java.io.Serializable;

import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.Term;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ValueConverter;

/**
 * AJEgɐݒ肳郍[̃fłB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class Role implements Serializable {
    /**
     * [ID
     */
    private final String roleId;
    /**
     * 
     */
//    private Term term = Term.getDefaultTerm();
    private Term term = null;
    /**
     * AJEg
     */
    private Account account;
    
    /**
     * RXgN^
     * 
     * @param roleId [ID
     */
    public Role(String roleId) {
        ValueConverter.checkNull(Const.ROLE_ID, roleId);
        this.roleId = roleId;
    }
    
    /**
     * [ID
     * 
     * @return [ID
     */
    public String getRoleId() {
        return this.roleId;
    }
    
    /**
     * AJEgݒ肵܂B
     * 
     * @param account AJEg
     */
    public void setAccount(Account account) {
        this.account = account;
    }

    /**
     * [UR[h擾܂B
     * 
     * @return [UR[h
     */
    public String getUserCode() {
        return (this.account == null) ? null : account.getUserCode();
    }

    /**
     * Ԃ擾܂B
     * 
     * @return 
     */
    public Term getTerm() {
        return term;
    }

    /**
     * Ԃݒ肵܂B
     * 
     * @param activation LJn
     * @param expiration LI
     */
    public void setTerm(String activation, String expiration) {
        this.term = new Term(activation, expiration);
    }
    
    
    public int hashCode() {
        return getRoleId().hashCode();
    }
    
    public boolean equals(Object obj) {
        if (obj == null || !(obj instanceof Role)) {
            return false;
        }
        return (this.hashCode() == obj.hashCode());
    }
}
