/*
 * UserTerminableInternational.java
 *
 * Created on 2005/03/31, 12:00:00
 */
package jp.co.intra_mart.tools.bm5.csv2xml.models.user;

import java.io.Serializable;
import java.util.Locale;

import jp.co.intra_mart.common.aid.jdk.java.util.LocaleUtil;
import jp.co.intra_mart.tools.bm5.csv2xml.common.Const;
import jp.co.intra_mart.tools.bm5.csv2xml.models.common.ValueConverter;

/**
 * [Ůԍۉ̃f[^舵܂B
 *
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class UserTermI18n implements Serializable {
	/**
	 * 
	 */
	private final Locale locale;
    /**
     * [U
     */
    private String name;

    /**
     * [UJi
     */
    private String nameSyllabary;

    /**
     * [Up
     */
    private String nameEnglish;

    /**
     * Z
     */
    private String address;

    /**
     * RXgN^
     * 
     * @param locale
     */
    public UserTermI18n(String locale) {
        ValueConverter.checkNull(Const.LOCALE, locale);
        this.locale = LocaleUtil.toLocale(locale);
    }
    
    /**
     * 擾܂B
     * 
     * @return 
     */
    public Locale getLocale() {
    	return this.locale;
    }
    
    /**
     * [U擾܂B
     * 
     * @return [U
     */
    public String getName() {
        return this.name;
    }

    /**
     * [Uݒ肵܂B
     * 
     * @param name [U
     */
    public void setName(String name) {
        ValueConverter.checkNull("", name);
        this.name = name;
    }

    /**
     * [UJi擾܂B
     * 
     * @return [UJi
     */
    public String getNameSyllabary() {
        return this.nameSyllabary;
    }

    /**
     * [UJiݒ肵܂B
     * 
     * @param nameSyllabary [UJi
     */
    public void setNameSyllabary(String nameSyllabary) {
        this.nameSyllabary = nameSyllabary;
    }

    /**
     * [Up擾܂B
     * 
     * @return [Up
     */
    public String getNameEnglish() {
        return this.nameEnglish;
    }

    /**
     * [Upݒ肵܂B
     * 
     * @param nameEnglish [Up
     */
    public void setNameEnglish(String nameEnglish) {
        this.nameEnglish = nameEnglish;
    }

    /**
     * Z擾܂B
     * 
     * @return Z
     */
    public String getAddress() {
        return this.address;
    }

    /**
     * Zݒ肵܂B
     * 
     * @param address Z
     */
    public void setAddress(String address) {
        this.address = address;
    }
}