package jp.co.intra_mart.tools.bm5.csv2xml.util;

import java.io.File;
import java.io.IOException;
import java.io.OutputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.xml.sax.SAXException;

/**
 * XMLIuWFNgE[eBeB
 * 
 * @since 5.1
 * @author INTRAMART
 * @version 1.0
 */
public class XmlUtil {

    /**
     * XMLhLg擾܂B
     * 
     * @return XMLhLg
     * @throws ParserConfigurationException
     */
    public static Document getDocument() 
    		throws ParserConfigurationException {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        return builder.newDocument();
    }

    /**
     * XMLhLg擾܂B
     * 
     * @param file
     * @param logger
     * @return XMLhLg
     * @throws ParserConfigurationException
     */
    public static Document getDocument(File file)
            throws ParserConfigurationException, SAXException, IOException {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        factory.setValidating(true);
        DocumentBuilder builder = factory.newDocumentBuilder();
        Document document = null;

        document = builder.parse(file);

        return document;
    }

    /**
     * XMLt@C̐s܂B
     * 
     * @param document
     *            XMLhLg
     * @param stream
     *            o̓Xg[
     * @throws TransformerException
     */
    public static void write(Document document, OutputStream stream)
            throws TransformerException {

        TransformerFactory factory = TransformerFactory.newInstance();
        Transformer transformer = factory.newTransformer();
        DOMSource source = new DOMSource(document);
        // oXMLt@Cݒ
        StreamResult target = new StreamResult(stream);

        transformer.setOutputProperty(OutputKeys.INDENT, "yes");
        transformer.setOutputProperty(OutputKeys.ENCODING, "UTF-8");
        transformer.transform(source, target);
    }
}
